unit graph4;
interface
uses graph;
type
colortype=0..16;
picture=array[0..500,1..120] of colortype;
zop=^picture;

function getwidth(adresse:zop):integer;
function getheight(adresse:zop):integer;
function setwidth(adresse:zop;width:integer):boolean;
function setheight(adresse:zop;height:integer):boolean;

function savepicture(adresse:zop;dateiname:string):boolean;
function loadpicture(adresse:zop;dateiname:string):boolean;
procedure putpicture(left,top:integer;adresse:zop);
function getpicture(left,top,width,height:integer;adresse:zop):boolean;
function partofpicture(left,top,width,height:integer;adresse:zop):boolean;

function log(basis,wert:longint):integer;
function expo(basis,exponent:integer):longint;
implementation



function log(basis,wert:longint):integer;
var lgb,lgw:real;

begin
if wert<=0 then log:=0 else
begin
lgb:=ln(basis)/ln(10);
lgw:=ln(wert)/ln(10);
log:=trunc(lgw/lgb);
end;
end;

function expo(basis,exponent:integer):longint;
var i:byte;
    w:longint;
begin
w:=1;
if (exponent>0) and (exponent<8) then
begin
if exponent=1 then w:=basis else
   begin
   for i:=1 to exponent do w:=w*basis;
   end;
end
else w:=0;
expo:=w;
end;

function getwidth(adresse:zop):integer;
var w:integer;
begin
w:=expo(17,adresse^[0,1]);
w:=w+adresse^[0,2]*17;
w:=w+adresse^[0,3];
getwidth:=w;
end;

function getheight(adresse:zop):integer;
var h:integer;
begin
h:=adresse^[0,4]*17;
h:=h+adresse^[0,5];
getheight:=h;
end;

function setwidth(adresse:zop;width:integer):boolean;
begin
if (width>0) and (width<=500) then
begin
adresse^[0,1]:=log(17,width);
adresse^[0,2]:=(width-expo(17,log(17,width))) div 17;
adresse^[0,3]:=(width-expo(17,log(17,width))) mod 17;
setwidth:=true;
end
else setwidth:=false;
end;

function setheight(adresse:zop;height:integer):boolean;
begin
if (height>0) and (height<=120) then
begin
adresse^[0,4]:=height div 17;
adresse^[0,5]:=height mod 17;
setheight:=true;
end
else setheight:=false;
end;

function savepicture(adresse:zop;dateiname:string):boolean;
var datei:file of picture;
begin
{$I-}
assign(datei,dateiname);
rewrite(datei);
write(datei,adresse^);
close(datei);
if ioresult<>0 then savepicture:=false else savepicture:=true;
{$I+}
end;

function loadpicture(adresse:zop;dateiname:string):boolean;
var datei:file of picture;
begin
{$I-}
assign(datei,dateiname);
reset(datei);
read(datei,adresse^);
close(datei);
if ioresult<>0 then loadpicture:=false else loadpicture:=true;
{$I+}
end;


procedure putpicture(left,top:integer;adresse:zop);
var x,y:integer;
begin
for y:=1 to getheight(adresse) do
for x:=1 to getwidth(adresse) do
begin
if adresse^[x,y]<16 then putpixel(left+x-1,top+y-1,adresse^[x,y]);
end;
end;

function getpicture(left,top,width,height:integer;adresse:zop):boolean;
var x,y:integer;
begin
if setheight(adresse,height) and setwidth(adresse,width) then
begin
for y:=1 to height do
for x:=1 to width do
begin
adresse^[x,y]:=getpixel(left+x-1,top+y-1);
end;
getpicture:=true;
end
else getpicture:=false;
end;

function partofpicture(left,top,width,height:integer;adresse:zop):boolean;
var x,y:integer;
begin
if (top + height <= 120) and (left + width <= 500) then
begin
for x:=1 to width do
for y:=1 to height do adresse^[x,y]:=adresse^[x+left,y+top];
if setwidth(adresse,width) and setheight(adresse,height) then partofpicture:=true else partofpicture:=false;
end
else partofpicture:=false;
end;

end.